<?php

/*
Golem RSS 2.0 - News-Grabber
Copyright 2005 by Netzwelt-Kali.de - Karl Fahrtmann

Basiert auf: Heise News Grabber
von: Matthias Zirngibl
http://masterbootrecord.de/docs/heisenewsgrabber.php
*/

$ENABLE_CACHING = false; // Vor dem Erlauben des Cachen der Daten bitte den korrekten Pfad angeben. Siehe $CACH_FILE
$CACHE_FILE = '/tmp/golem.xml'; // Dies ist der Pfad und der Dateiname, wo die Daten zwischengespeichert werden. Siehe $ENABLE_CACHING
//$CACHE_FILE = 'c://temp//golem.xml'; //Fuer Windows
$CACHE_REFRESH_TIME = 20; //Zeit in Minuten, die die Daten zwischengespeichert werden
$MAX_NEWS = 100; //Gibt an, wieviele Schlagzeilen angezeigt werden sollen
$newsfile = "http://www.golem.de/rss.php?feed=RSS2.0"; // Adresse des RSS-Files auf dem Golem-Server
$kommentieren = true; // Bei true wird der entsprechende Link zum Golem-Forum angegeben.
$schlagzeile = true; // Bei false wird nur die Schlagzeile ausgegeben, bei true auch eine Kurzbeschreibung

if ($ENABLE_CACHING){
	$cache_diff =(time() - @filemtime($CACHE_FILE))/60;
	if (!file_exists($CACHE_FILE) or ($cache_diff > 20) ){
		$fcontents = join ('', @file ($newsfile));
		@unlink($CACHE_FILE);
		$handle = @fopen($CACHE_FILE, 'x+');
		@fwrite($handle, $fcontents);
		@fclose($handle);
	}
	$fcontents = join ('', @file ($CACHE_FILE));
} else {
	$fcontents = join ('', @file ($newsfile));
}
$fcontents = str_replace ("</item>", "", $fcontents);
$fcontents = str_replace ("</title>", "", $fcontents);
$fcontents = str_replace ("</link>", "", $fcontents);
$fcontents = str_replace ("</description>", "", $fcontents);
$fcontents = str_replace ("</comments>", "", $fcontents);
$fcontents = str_replace ("</pubDate>", "", $fcontents);
$fcontents = str_replace ("</guid>", "", $fcontents);
$fcontents = str_replace ("", "&auml;", $fcontents); // Umlaute kodieren
$fcontents = str_replace ("", "&ouml;", $fcontents);
$fcontents = str_replace ("", "&uuml;", $fcontents);
$fcontents = str_replace ("", "&Auml;", $fcontents);
$fcontents = str_replace ("", "&Ouml;", $fcontents);
$fcontents = str_replace ("", "&uuml;", $fcontents);
$fcontents = str_replace ("", "&szlig;", $fcontents);
$fcontents = str_replace ("-", "- ", $fcontents); // Nach Bindestrich ein Leerzeichen einfuegen, wegen Umbruch fuer Mozilla
$fcontents = str_replace ("-  ", "- ", $fcontents);

$splices = explode ("<item>", $fcontents);

if (count($splices) > $MAX_NEWS){
	$stop_at = $MAX_NEWS;
} else {
	$stop_at = count($splices);
}
$news = "";
$out_buffer = "<div class=\"golemnews\"><h2><a href=\"http://www.golem.de/\" target=\"_blank\">IT-News f&uuml;r Profis</a></h2>\n";
for ($i = 1; $i < $stop_at; $i++){
	$guid = explode("<guid>",$splices[$i]);
	$datum = explode("<pubDate>",$guid[0]);
	$forum = explode("<comments>",$datum[0]);
	$beschreibung = explode("<description>",$forum[0]);
	$link = explode("<link>",$beschreibung[0]);
	$titel = explode("<title>",$link[0]);
	$datum = explode(" ",$datum[1]);
	$datum = $datum[1]." ".$datum[2]." ".$datum[3]." ".$datum[4]." Uhr";
	$link[1] = strip_tags($link[1]);
	$news = $news."<div class=\"golemnewsblock\">\n<div class=\"newsblockkopf\">\n";
	$news = $news."<p><small>".$datum.":</small> <a href=\"". trim($link[1])."\" target=\"_blank\">".trim($titel[1])."</a></p>\n";
	if ($kommentieren) $news = $news."<p><small><a href=\"". trim($forum[1])."\" target=\"_blank\">Hier Klicken zum Kommentieren dieser Meldung.</a></small></p>\n";
	$news = $news."</div>\n";
	if ($schlagzeile) $news = $news."<div class=\"golemnewskoeper\"><p>".trim($beschreibung[1])."</p></div>\n";
	$news = $news."</div>\n";
}
$out_buffer = $out_buffer.$news."</div>\n";
echo $out_buffer;
?>
